//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTBASE_H_
#define _GLGTBASE_H_
//#define _WIN32_WINNT 0x0500 //SendInput()g

#include <windows.h>
#include <iostream> //fobOp
#include <GL/gl.h>
#include <GL/glu.h>




typedef unsigned int GLGTEnum; ///< rbgtO
typedef unsigned char GLGTWindowStyle; ///< EBhẼX^C

//
#define GLGT_NONE                       0x00000000
#define GLGT_DEFAULT                    0x00000000

#define GLGT_DISABLE                    0x00000000
#define GLGT_ENABLE                     0x00000001
#define GLGT_TOGGLE                     0x00000002

// }EX{^̏Ԃ̃}XN
#define GLGT_MOUSEUP                    0x00000000
#define GLGT_MOUSEDOWN                  0x00000001

// L[̏Ԃ̃}XN
#define GLGT_KEYUP                      0x00000000
#define GLGT_KEYDOWN                    0x00000001


// EBhEX^C̃}XN(GLGTWindowStyle)
#define GLGT_MAXIMIZEBOX  WS_MAXIMIZEBOX ///< ő剻{^
#define GLGT_MINIMIZEBOX  WS_MINIMIZEBOX ///< ŏ{^
#define GLGT_SIZEBOX      WS_SIZEBOX     ///< TCYύXłEBhE̘g




//********************************************************************
/// \brief [eBeB̎
/// 
/// 
/// 
/// 
enum GLGTUtilityType {
    GLGTUTILITYTYPE_UTILITY,
    GLGTUTILITYTYPE_TIME,
    GLGTUTILITYTYPE_PROFILER,
    GLGTUTILITYTYPE_KEY,
    GLGTUTILITYTYPE_MOUSE,
    GLGTUTILITYTYPE_SHAPES,
    GLGTUTILITYTYPE_MATH,
    GLGTUTILITYTYPE_TEXTUREMANAGER,
    GLGTUTILITYTYPE_MODELMANAGER,
    GLGTUTILITYTYPE_FONTRENDERER,


    GLGTFLAGARRAYSIZE_GLGTUTILITYTYPE
};


//********************************************************************
/// \brief Cxg̎
/// 
/// 
/// 
/// 
enum GLGTEventType {
    GLGTEVENT_IDLE,

    GLGTEVENT_DRAW,

    GLGTEVENT_ENTERSCENE,
    GLGTEVENT_LEAVESCENE,

    GLGTEVENT_MOVEWINDOW,
    GLGTEVENT_RESIZEWINDOW,

    GLGTEVENT_KEYDOWN,
    GLGTEVENT_KEYUP,

    GLGTEVENT_MOUSEDOWN,
    GLGTEVENT_MOUSEUP,
    GLGTEVENT_MOUSEMOVE,

    GLGTEVENT_MOVEFORM,
    GLGTEVENT_RESIZEFORM,



    GLGTEVENT_SIZE
};






//********************************************************************
// }N

//////////////////////////////////////////////////
/// \brief J
/// 
/// 
#define GLGTSAFEDELETE(p)       { if(p) { delete (p);     (p)=NULL; } }

//////////////////////////////////////////////////
/// \brief z̃J
/// 
/// 
#define GLGTSAFEDELETEARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }



#ifndef NDEBUG
  #ifndef GLGT_USE_GLGTASSERT
    #define GLGT_USE_GLGTASSERT
  #endif
#endif
#ifdef GLGT_USE_GLGTASSERT
extern bool GLGTAssertFunction(const char* expression, const char* filename, unsigned int lineno, bool* ignore);
//////////////////////////////////////////////////
/// \brief AT[g}N
/// 
/// expȔꍇAG[bZ[W\As邩IԁB
/// sȂꍇDebugBreak()Ăяou[NB
/// I񂾏ꍇ́Aȍ~G[bZ[W\ɑsB
///
/// fobOrh(NDEBUG`ĂȂ)ɂ̂ݓWJB
/// fobOrhȊOɂgpꍇGLGT_USE_GLGTASSERT`B
///
#define GLGTASSERT(exp) { \
            static bool ignore_always = false; \
            if(!(exp)) { \
                if(GLGTAssertFunction(#exp, __FILE__, __LINE__, &ignore_always)) {DebugBreak();} \
            } \
        }
#else
#define GLGTASSERT(exp) ((void)0)
#endif



#ifndef NDEBUG
  #ifndef GLGT_USE_GLGTCHECKGLERROR
    #define GLGT_USE_GLGTCHECKGLERROR
  #endif
#endif
#ifdef GLGT_USE_GLGTCHECKGLERROR
extern bool GLGTCheckGLErrorFunction(GLenum err, const char* filename, unsigned int lineno, bool* ignore);
//////////////////////////////////////////////////
/// \brief OpenGL̃G[`FbN}N
/// 
/// glGetError()̖߂lGL_NO_ERRORoȂꍇAG[bZ[W\As邩IԁB
/// sȂꍇDebugBreak()Ăяou[NB
/// I񂾏ꍇ́Aȍ~G[bZ[W\ɑsB
///
/// fobOrh(NDEBUG`ĂȂ)ɂ̂ݓWJB
/// fobOrhȊOɂgpꍇGLGT_USE_GLGTCHECKGLERROR`B
///
#define GLGTCHECKGLERROR() { \
            static bool ignore_always = false; \
            GLenum err = glGetError(); \
            if(err != GL_NO_ERROR) { \
                if(GLGTCheckGLErrorFunction(err, __FILE__, __LINE__, &ignore_always)) {DebugBreak();} \
            } \
        }
#else
#define GLGTCHECKGLERROR() ((void)0)
#endif












#endif
