//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTMAINWINDOW_H_
#define _GLGTMAINWINDOW_H_

#include <string>
#include "GLGTBase.h"
#include "GLGTFlagArray.h"
#include "GLGTScene.h"
#include "GLGTProfiler.h"
#include "GLGTKey.h"
#include "GLGTMouse.h"
#include "GLGTFlagArray.h"
#include "GLGTWindowProperty.h"
#include "GLGTMouseCursor.h"

#ifndef WM_MOUSEWHEEL
#define WM_MOUSEWHEEL (WM_MOUSELAST+1) ///< WM_MOUSEWHEELtbN邽
#endif


#define REPEATED_KEYMASK  (1<<30) ///< L[s[g̃}XN


//********************************************************************
/// \brief EBhE쐬EǗB
/// 
/// 
/// 
/// 
class GLGTMainWindow : public GLGTScene {
    // vpeB ****************************************
public:
protected:
    //////////////////////////////////////////////////
    //EBhẼf[^
    WNDCLASSEX wndClass;                                    ///< EChENX\
    HGLRC hRC;                                              ///< OpenGL_OReLXg
    std::string className;                                  ///< EChENX
    GLGTWindowProperty property;                            ///< EBhE֘ÃvpeB

    //////////////////////////////////////////////////
    //sNZtH[}bg̃f[^
    unsigned long pixelBufferFlags;                         ///< sNZobt@̃rbgtO
    unsigned char pixelType;                                ///< sNZ̃J[f[^
    unsigned char colorBits;                                ///< J[̃rbg
    unsigned char redBits;                                  ///< ԃrbg
    unsigned char redShift;                                 ///< ԃrbgׂ̈̃VtgJEg
    unsigned char greenBits;                                ///< ΃rbg
    unsigned char greenShift;                               ///< ΃rbgׂ̈̃VtgJEg
    unsigned char blueBits;                                 ///< RGBAJ[obt@̐rbg
    unsigned char blueShift;                                ///< rbgׂ̈̃VtgJEg
    unsigned char alphaBits;                                ///< At@rbg
    unsigned char alphaShift;                               ///< At@rbgׂ̈̃VtgJEg
    unsigned char accumBits;                                ///< AL[Vobt@̃sNZ̃rbg
    unsigned char accumRedBits;                             ///< AL[Vobt@̃sNZ̐ԃrbg
    unsigned char accumGreenBits;                           ///< AL[Vobt@̃sNZ̗΃rbg
    unsigned char accumBlueBits;                            ///< AL[Vobt@̃sNZ̐rbg
    unsigned char accumAlphaBits ;                          ///< AL[Vobt@̃sNZ̃At@rbg
    unsigned char depthBits;                                ///< fvXobt@̃sNZ̃rbg
    unsigned char stencilBits;                              ///< XeVobt@̃sNZ̃rbg
    unsigned char layerType;                                ///< C^Cv(Win32łPFD_MAIN_PLANEłKv)
    unsigned char reserved;;                                ///< I[o[CƃA_[C̐






private:


    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTMainWindow(void);
    
    //////////////////////////////////////////////////
    /// \brief fXgN^
    virtual ~GLGTMainWindow(void);


    //////////////////////////////////////////////////
    /// \brief EBhE쐬
    ///
    /// run()Ăяo܂ł͌Ȃ
    bool create(void);
    
    //////////////////////////////////////////////////
    /// \brief j
    void destroy(void);
    
    //////////////////////////////////////////////////
    /// \brief s
    ///
    /// EBhE\Scenẽ[vɓ
    /// 
    bool run(void);





    //////////////////////////////////////////////////
    // bZ[WU蕪EBhEvV[W
    // ̃bZ[WāAIuWFNgMainWindowProcĂяo
    static LRESULT CALLBACK MainWindowProc(HWND hwnd_, UINT umsg_, WPARAM wparam_, LPARAM lparam_);




    //////////////////////////////////////////////////
    /// \brief [Cxg] EBhE쐬Ƃ̑O
    /// 
    /// EChEOpenGL̏E쐬O
    /// 
    /// \warning ̎_OpenGL̖߂Ăяoׂł͂Ȃ
    virtual void onCreateWindow(void);

    //////////////////////////////////////////////////
    /// \brief [Cxg] {^ꂽƂ
    /// \retval true I
    /// \retval true IȂ
    virtual bool onCloseWindow(void);

    //////////////////////////////////////////////////
    /// \brief [Cxg] EChEjƂ
    virtual void onDestroyWindow(void);




    // J ****************************************
private:
    //////////////////////////////////////////////////
    /// \brief vpeB
    void clear(void);

    //////////////////////////////////////////////////
    /// \brief foCXReLXgݒ肷B(sNZtH[}bgyу_OReLXg)
    /// \retval true 
    /// \retval false s
    bool initGLWindow(void);

    //////////////////////////////////////////////////
    /// \brief foCXReLXgƃ_OReLXgJ
    void releaseGLWindow(void);

    //////////////////////////////////////////////////
    /// \brief EBhEnhCWndBaseIuWFNgѕt
    /// \retval true 
    /// \retval false s
    bool attachObject(void);

    //////////////////////////////////////////////////
    // <Es> detachObject
    /// \brief EBhEnhCWndBaseIuWFNg؂藣
    /// \retval true 
    /// \retval false s
    bool detachObject(void);



};


#endif
