//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTRECTBOX_H_
#define _GLGTRECTBOX_H_

#include "GLGTBase.h"
#include "GLGTMath.h"
#include "GLGTColor.h"
#include "GLGTTextureManager.h"



//********************************************************************
/// \brief ``NXB
/// 
/// PF܂̓eNX`ŋ``B
/// 
/// 
class GLGTRectBox {

protected:
    const GLGTRectEXT* ptrRectBoxRect; ///< {bNẌʒuE傫
    GLGTColor4<unsigned char> rectColor; //<`̐F
    GLGTTexture rectTexture; ///< `̃eNX`
    unsigned int rectTextureID; ///< eNX`ID

    GLGTRect<float> rectTextureCoord; ///< eNX`W(ʍ_)




public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTRectBox(const GLGTRectEXT* in_rect);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    virtual ~GLGTRectBox();



    //////////////////////////////////////////////////
    /// \brief FZbg
    void setRectColor(unsigned char r,unsigned char g,unsigned char b,unsigned char a) {
        rectColor.set(r,g,b,a);
    }
    //////////////////////////////////////////////////
    /// \brief FZbg
    void setRectColor(GLGTColor4<unsigned char>& in_color) { rectColor = in_color;}

    //////////////////////////////////////////////////
    /// \brief eNX`Zbg
    void setRectTexture(const std::string& filename);
    //////////////////////////////////////////////////
    /// \brief eNX`Zbg
    void setRectTexture(const GLGTTexture& in_texture);

    //////////////////////////////////////////////////
    /// \brief eNX`
    void unsetRectTexture(void);

    //////////////////////////////////////////////////
    /// \brief eNX`WZbg
    /// 
    void setRectTextureCoord(float in_left, float in_right, float in_top, float in_bottom) {
        rectTextureCoord.set(in_left, in_right, in_top, in_bottom);;
    }




    //////////////////////////////////////////////////
    /// \brief ``悷B
    void drawRect(unsigned int projectionwidth, unsigned int projectionheight);

};


#endif
