//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTUtility.h"



//////////////////////////////////////////////////
GLGTUtility_Singleton::GLGTUtility_Singleton(void){
    fpsInterval = 1000;
    fps = 0;
    lastFps = 0;
}

//////////////////////////////////////////////////
GLGTUtility_Singleton::~GLGTUtility_Singleton(){
}

//////////////////////////////////////////////////
bool GLGTUtility_Singleton::parseString(std::vector<std::string>& data, const std::string& str) const {
    data.clear();
    std::string::size_type top = 0;
    std::string::size_type strsize = str.size();
    for(std::string::size_type i = 0;i < strsize; i++){
        if((str[i] == ' ')||(str[i] == '\t')||(str[i] == '\v')||(str[i] == '\n')||(str[i] == '\r')||(str[i] == '\f')) {
            if(top < i) {
                data.push_back(str.substr(top,i-top));
            }
            top = i+1;
        }
        else if(str[i] == '\"'){
            if(top < i) { // "̑OɃXy[XȂꍇ
                data.push_back(str.substr(top, i-top));
            }
            i++;
            top = i;
            if(i >= strsize) {return false;}
            while(str[i] != '\"') {
                i++;
                if(i >= strsize) {return false;}
            }
            if(top < i) {
                data.push_back(str.substr(top, i-top));
            }
            top = i+1;
        }
    }
    if(top < i) {
        data.push_back(str.substr(top,i-top));
    }
    return true;

}

//////////////////////////////////////////////////
std::string GLGTUtility_Singleton::getComment(const std::string& str, const std::string& comment) const {
    std::string::size_type commentsize = comment.size();
    if(commentsize == 0) {return (std::string)"";}
    if(str.size() < comment.size()) {return (std::string)"";}

    std::string::size_type max = str.size()-commentsize;
    for(std::string::size_type i = 0; i <= max; i++) {
        // ""͔΂
        if(str[i] == '\"') {
            i++;
            if(i > max) {break;}
            while(str[i] != '\"') {
                i++;
                if(i>max) {return (std::string)"";}
            }
            continue;
        }
        for(std::string::size_type j = 0; j < commentsize; j++) {
            if(str[i+j] != comment[j]) {
                break;//̃[vɖ߂
            }
            else if(j == commentsize-1) { // SɈv
                //str.erase(i);
                //str = str.substr(0,i);
                return str.substr(i+commentsize);
            }
        }
    }
    return (std::string)"";

}


//////////////////////////////////////////////////
void GLGTUtility_Singleton::removeComment(std::string& str, const std::string& comment) const {
    std::string::size_type commentsize = comment.size();
    if(commentsize == 0) {return;}
    if(str.size() < commentsize) {return;}

    std::string::size_type max = str.size()-commentsize;
    for(std::string::size_type i = 0; i <= max; i++) {
        // ""͔΂
        if(str[i] == '\"') {
            i++;
            if(i > max) {break;}
            while(str[i] != '\"') {
                i++;
                if(i>max) {return;}
            }
            continue;
        }
        for(std::string::size_type j = 0; j < commentsize; j++) {
            if(str[i+j] != comment[j]) {
                break;//̃[vɖ߂
            }
            else if(j == commentsize-1) { // SɈv
                str.erase(i);
                //str = str.substr(0,i);
                return;
            }
        }
    }
}

