#ifndef _GLGT_H_
#define _GLGT_H_

#include "GLGTBase.h"
#include "GLGTFlagArray.h"

#include "GLGTUtility.h"
#include "GLGTTime.h"
#include "GLGTProfiler.h"
#include "GLGTMath.h"
#include "GLGTColor.h"
#include "GLGTKey.h"
#include "GLGTMouse.h"
#include "GLGTShapes.h"
#include "GLGTTextureManager.h"
#include "GLGTModel.h"
#include "GLGTModelManager.h"
#include "GLGTFontRenderer.h"


#include "GLGTScene.h"
#include "GLGTMainWindow.h"

#include "GLGTForm.h"


//////////////////////////////////////////////////
extern bool GLGTInit(GLGTFlagArray<GLGTUtilityType>& utility);
extern bool GLGTInit(void);

//////////////////////////////////////////////////
extern void GLGTQuit(void);





#endif
