//********************************************************************
/// \file
/// 
/// Ƃ肠{L[{[hɂ
/// 
/// 
//********************************************************************
#ifndef _GLGTKEY_H_
#define _GLGTKEY_H_

#include <string>

#include "GLGTBase.h"
#include "GLGTSingleton.h"

#define GLGTKey    GLGTKey_Singleton::getSingleton() ///< CX^XɃANZX
#define ptrGLGTKey    GLGTKey_Singleton::getSingletonPtr()  ///< CX^X̃|C^ɃANZX

#define KEYMAPSIZE    257 ///< Windows256 (֋XA+1Ă)
#define OSKeyCode     unsigned int ///< OSŗL̃L[R[h(Windowsunsigned int)

//********************************************************************
/// \brief L[R[h
/// 
enum GLGTKeyCode {
    KEY_UNKNOWN         =   0,
    KEY_FIRST           =   0,

    ///AXL[R[hƓ
    KEY_BACKSPACE       =   8, ///< VK_BACK
    KEY_TAB             =   9, ///< VK_TAB
    KEY_RETURN          =  13, ///< VK_RETURN
    KEY_PAUSE           =  19, ///< VK_PAUSE
    KEY_ESCAPE          =  27, ///< VK_ESCAPE
    KEY_SPACE           =  32, ///< VK_SPACE
    KEY_COMMA           =  44, ///< VK_OEM_COMMA
    KEY_MINUS           =  45, ///< VK_OEM_MINUS
    KEY_PERIOD          =  46, ///< VK_OEM_PERIOD
    KEY_SLASH           =  47, ///< VK_OEM_2
    KEY_0               =  48, ///< '0'
    KEY_1               =  49,
    KEY_2               =  50,
    KEY_3               =  51,
    KEY_4               =  52,
    KEY_5               =  53,
    KEY_6               =  54,
    KEY_7               =  55,
    KEY_8               =  56,
    KEY_9               =  57,
    KEY_COLON           =  58, ///< VK_OEM_1
    KEY_SEMICOLON       =  59, ///< VK_OEM_PLUS
    KEY_A               =  65, ///< 'A'
    KEY_B               =  66,
    KEY_C               =  67,
    KEY_D               =  68,
    KEY_E               =  69,
    KEY_F               =  70,
    KEY_G               =  71,
    KEY_H               =  72,
    KEY_I               =  73,
    KEY_J               =  74,
    KEY_K               =  75,
    KEY_L               =  76,
    KEY_M               =  77,
    KEY_N               =  78,
    KEY_O               =  79,
    KEY_P               =  80,
    KEY_Q               =  81,
    KEY_R               =  82,
    KEY_S               =  83,
    KEY_T               =  84,
    KEY_U               =  85,
    KEY_V               =  86,
    KEY_W               =  87,
    KEY_X               =  88,
    KEY_Y               =  89,
    KEY_Z               =  90,
    KEY_LBRACKET        =  91, ///< VK_OEM_4
    KEY_BACKSLASH       =  92, ///< VK_OEM_5
    KEY_RBRACKET        =  93, ///< VK_OEM_6
    KEY_CARET           =  94, ///< VK_OEM_7
    KEY_BACKQUOTE       =  96, ///< VK_OEM_3 (`)
    //܂ŃAXL[R[h

    //NUMPAD
    KEY_NUM_0           = 256,
    KEY_NUM_1                ,
    KEY_NUM_2                ,
    KEY_NUM_3                ,
    KEY_NUM_4                ,
    KEY_NUM_5                ,
    KEY_NUM_6                ,
    KEY_NUM_7                ,
    KEY_NUM_8                ,
    KEY_NUM_9                ,
    KEY_NUM_DECIMAL          , ///< num .
    KEY_NUM_DIVIDE           , ///< num /
    KEY_NUM_MULTIPLY         , ///< num *
    KEY_NUM_SUBTRACT         , ///< num -
    KEY_NUM_ADD              , ///< num +
    KEY_NUM_SEPARATOR        , ///< num enter

    // 󂠂̃L[
    KEY_INSERT               , ///< VK_INSERT
    KEY_DELETE               , ///< VK_DELETE
    KEY_HOME                 , ///< VK_HOME
    KEY_END                  , ///< VK_END
    KEY_PAGEUP               , ///< VK_PRIOR
    KEY_PAGEDOWN             , ///< VK_NEXT
    KEY_UP                   , ///< VK_UP
    KEY_DOWN                 , ///< VK_DOWN
    KEY_RIGHT                , ///< VK_RIGHT
    KEY_LEFT                 , ///< VK_LEFT

    // t@NVL[
    KEY_F1                   ,
    KEY_F2                   ,
    KEY_F3                   ,
    KEY_F4                   ,
    KEY_F5                   ,
    KEY_F6                   ,
    KEY_F7                   ,
    KEY_F8                   ,
    KEY_F9                   ,
    KEY_F10                  ,
    KEY_F11                  ,
    KEY_F12                  ,

    //ft@CL[
    KEY_NUMLOCK              , ///< 
    KEY_CAPSLOCK             , ///< VK_CAPITAL
    KEY_SCROLLOCK            , ///< 
    KEY_SHIFT                , ///< VK_SHIFT
    KEY_CTRL                 , ///< VK_CONTROL
    KEY_ALT                  , ///< VK_MENU
    KEY_RSHIFT               , ///< 
    KEY_LSHIFT               , ///< 
    KEY_RCTRL                , ///< 
    KEY_LCTRL                , ///< 
    KEY_RALT                 , ///< 
    KEY_LALT                 , ///< 

    //̑
    KEY_PRINTSCREEN          , ///< VK_SNAPSHOT
    KEY_BACKSLASH102         , ///< VK_OEM_102 (RT 102-key L[{[hp [\\_])


    KEY_LAST                   ///< Xg

};

//********************************************************************
/// \brief L[VOgNX
///
/// GLGTKey_SingletonGLGTInitŃRXgNgA
/// GLGTQuitŃfXgNgB
/// GLGTKeyŃCX^XɃANZX (FGLGTKey.getKeyCode())
/// 
/// 
class GLGTKey_Singleton : public GLGTSingleton <GLGTKey_Singleton> {

    // vpeB ****************************************
public:



protected:
    GLGTKeyCode KeyMap[KEYMAPSIZE]; ///< OSŗL̃L[R[hGLGT̃L[R[hΉ\
    std::string KeyName[KEY_LAST]; ///< GLGT̃L[R[h̖O
    char KeyChar[KEY_LAST][2]; ///< L[R[hɑΉLN^BQڂ0ȂshiftA1ȂshiftL



private:


  // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTKey_Singleton(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTKey_Singleton();



    //////////////////////////////////////////////////
    /// \brief destroy
    void destroy(void);

    //////////////////////////////////////////////////
    /// \brief vpeB
    void clear(void);


    //////////////////////////////////////////////////
    /// \brief GLGT̃L[R[hOSŗL̃L[R[h𓾂B
    /// \param keycode GLGT̃L[R[h
    /// \return OSŗL̃L[R[h
    /// \retval KEYMAPSIZE YL[R[h
    OSKeyCode getOSKeyCode(GLGTKeyCode keycode);

    //////////////////////////////////////////////////
    /// \brief AvP[ṼbZ[WȂǂœOSŗL̃L[R[hGLGT̃L[R[h𓾂
    /// \param oskey OSŗL̃L[R[h
    /// \return GLGT̃L[R[h
    /// \retval KEY_UNKNOWN s
    GLGTKeyCode getKeyCode(OSKeyCode oskey) {
        if(oskey < KEYMAPSIZE) {return KeyMap[oskey];}
        return KEY_UNKNOWN;
    }

    //////////////////////////////////////////////////
    /// \brief L[̖O𓾂
    /// \param keycode GLGT̃L[R[h
    /// \return L[̖O
    std::string& getKeyName(GLGTKeyCode keycode) {
        if(keycode < KEY_LAST){
            return KeyName[keycode];
        }
        return KeyName[KEY_UNKNOWN];

    }

    //////////////////////////////////////////////////
    /// \brief L[̃LN^𓾂
    /// \param keycode GLGT̃L[R[h
    /// \param is_shift VtgĂ邩
    /// \param is_capslock Caps LockON
    /// \return L[̃LN^
    ///  
    /// BSRETURNł̓GXP[vLN^Ԃ
    char getKeyChar(GLGTKeyCode keycode, bool is_shift, bool is_capslock) {
        unsigned int shift;
        if((keycode >= KEY_A)&&(keycode <= KEY_Z)) { //At@xbgȂCapsLock肷
            if(is_shift == is_capslock){shift = 0;}
            else {shift = 1;}
        }
        else {
            if(is_shift){shift = 1;}
            else {shift = 0;}
        }
        if(keycode < KEY_LAST){return KeyChar[keycode][shift];}
        return KeyName[KEY_UNKNOWN][shift];
    }

    //////////////////////////////////////////////////
    /// \brief w肵L[Ă邩ǂׂ
    /// \param keycode GLGT̃L[R[h
    /// \retval GLGT_KEYDOWN Ă
    /// \retval GLGT_KEYUP ĂȂ(܂͕sȃL[)
    GLGTEnum getKeyState(GLGTKeyCode keycode) {
        OSKeyCode oskey = getOSKeyCode(keycode);
        if(oskey == KEYMAPSIZE) {return GLGT_KEYUP;}//YL[Ȃꍇ

        if(GetKeyState(oskey) < 0) {return GLGT_KEYDOWN; }
        return GLGT_KEYUP;
    }


    // J ****************************************
protected:



private:
    //////////////////////////////////////////////////
    /// \brief =
    ///
    /// ȂB
    /// 
    GLGTKey_Singleton& operator =(const GLGTKey_Singleton& in) const {}







};



#endif
