//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTMODELMANAGER_H_
#define _GLGTMODELMANAGER_H_

#include <vector>
#include <fstream>
#include <sstream>
#include <string>

#include "GLGTBase.h"
#include "GLGTSingleton.h"
#include "GLGTUtility.h"
#include "GLGTTextureManager.h"
#include "GLGTModel.h"

#define GLGTModelManager      GLGTModelManager_Singleton::getSingleton() ///< CX^XɃANZX
#define ptrGLGTModelManager   GLGTModelManager_Singleton::getSingletonPtr() ///< CX^X̃|C^ɃANZX

//********************************************************************
/// \brief ff[^(GLGTModel)ǗVOgNX
///
/// \attention eXgiKȂ̂Ń`N`łB
///
/// GLGTModelManager_SingletonGLGTInitŃRXgNgA
/// GLGTQuitŃfXgNgB<BR>
/// GLGTModelManagerŃCX^XɃANZX (FGLGTModelManager.)
/// <BR>
/// 
/// 
/// <BR>
/// MQOǂݍ݂ eccentric army <http://alb.hp.infoseek.co.jp/> ŌJĂ\[XR[hQlɂĂ܂B
/// 
class GLGTModelManager_Singleton : public GLGTSingleton <GLGTModelManager_Singleton> {
    // vpeB ****************************************
public:



protected:
    std::vector<GLGTModel<> > model;



private:

    
    
    // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTModelManager_Singleton(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTModelManager_Singleton();



    //////////////////////////////////////////////////
    /// \brief j
    void destroy(void);

    //////////////////////////////////////////////////
    /// \brief vpeB
    void clear(void);




    //////////////////////////////////////////////////
    /// \brief nameɊY郂f̃|C^Ԃ
    /// \param in_modelname f
    /// \return f
    /// \retval NULL Y郂fȂ
    GLGTModel<>* getModel(const std::string& in_modelname);
    

    //////////////////////////////////////////////////
    /// \brief Vf[hĒǉ
    ///
    /// typeMODEL_UNKNOWNw肵ꍇ͔ʂēǂݍ
    /// <BR>
    /// łɑ݂Ăꍇ͂̃f̃|C^Ԃ
    ///
    /// \param in_modelname f(t@C)
    /// \param type f̃^Cv
    /// \return ǉf̃|C^
    /// \retval NULL ǉs([hłȂA܂͕ێłő吔ɒBĂ)
    GLGTModel<>* pushModel(const std::string& in_modelname, GLGTModelType type = MODEL_UNKNOWN);
    
    //////////////////////////////////////////////////
    /// \brief fǉ([hȂ)
    ///
    /// łɑ݂Ăꍇ͂̃f̃|C^Ԃ
    ///
    /// \attention ǉ郂f[hł[hȂB
    ///
    /// \param in_model ǉ郂f
    /// \return ǉf̃|C^
    /// \retval NULL ǉs
    GLGTModel<>* pushModel(const GLGTModel<>& in_model);
    
    //////////////////////////////////////////////////
    /// \brief Ōɒǉf폜
    ///
    /// 
    ///
    /// \return 폜f̃CfbNX(̏ꍇ0Ԃ)
    unsigned int popModel(void);

    //////////////////////////////////////////////////
    /// \brief t@C烂f[h
    ///
    /// in_modelɂ̓t@CZbgĂȂ΂ȂȂ
    ///
    /// \param in_model Zbg郂f
    /// \retval true 
    /// \retval false s
    bool loadModel(GLGTModel<>& in_model) const;
    
    //////////////////////////////////////////////////
    /// \brief MQOt@C烂f[h
    ///
    /// in_modelɂ̓t@CZbgĂȂ΂ȂȂ
    ///
    /// \attention Metasequoiał́A|S()v肪\Ƃ݂Ȃ܂A
    ///            OpenGLł͕ʔv肪\Ȃ̂ŁAǂݍނƂtɊi[܂B
    ///
    /// \param in_model Zbg郂f
    /// \retval true 
    /// \retval false s
    bool loadMQOModel(GLGTModel<>& in_model) const;
        
    //////////////////////////////////////////////////
    /// \brief eNX`ɃANZX
    GLGTModel<>& operator [](unsigned int i) {
        GLGTASSERT(i<model.size());
        return model[i];
    }


    // getter/setter ****************************************
  
    //////////////////////////////////////////////////
    /// \brief getter of 
    // get(void) const {}  
    //////////////////////////////////////////////////
    /// \brief setter of 
    //void set( in_) {}




  
    // J ****************************************
protected:



private:
    //////////////////////////////////////////////////
    /// \brief =
    ///
    /// ȂB
    /// 
    GLGTModelManager_Singleton& operator =(const GLGTModelManager_Singleton& in) const {}

    //////////////////////////////////////////////////
    /// \brief vpeB
    //void clear(void);
    
    
    
    
    //////////////////////////////////////////////////
    /// \brief 
    /// \param 
    /// \return 
    /// \retval 
    //void (void);








};


#endif
