//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTMOUSE_H_
#define _GLGTMOUSE_H_

#include <string>

#include "GLGTBase.h"
#include "GLGTSingleton.h"

#define GLGTMouse    GLGTMouse_Singleton::getSingleton() ///< CX^XɃANZX
#define ptrGLGTMouse    GLGTMouse_Singleton::getSingletonPtr() ///< CX^X̃|C^ɃANZX


//********************************************************************
/// \brief }EX{^
///
typedef enum {
    MOUSE_UNKNOWN      = 0,
    MOUSE_LEFTBUTTON      ,
    MOUSE_RIGHTBUTTON     ,
    MOUSE_MIDDLEBUTTON    ,
    MOUSE_WHEELDOWN       ,
    MOUSE_WHEELUP         ,
    MOUSE_LAST
} GLGTMouseButton;



//********************************************************************
/// \brief }EXVOgNX
///
/// GLGTMouse_SingletonGLGTInitŃRXgNgA
/// GLGTQuitŃfXgNgB<BR>
/// GLGTMouseŃCX^XɃANZX (FGLGTMouse.getMouseButtonName())
/// 
/// 
class GLGTMouse_Singleton : public GLGTSingleton <GLGTMouse_Singleton> {

    // vpeB ****************************************
public:



protected:
    std::string MouseButtonName[MOUSE_LAST];///< }EX{^̖O



private:


  // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTMouse_Singleton(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTMouse_Singleton();



    //////////////////////////////////////////////////
    /// \brief destroy
    void destroy(void);

    //////////////////////////////////////////////////
    /// \brief vpeB
    void clear(void);


    //////////////////////////////////////////////////
    /// \brief }EX{^̖O𓾂
    /// \param mousebutton }EX{^
    /// \return {^
    std::string& getMouseButtonName(GLGTMouseButton mousebutton) {
        if(mousebutton < MOUSE_LAST) {
            return MouseButtonName[mousebutton];
        }
        return MouseButtonName[MOUSE_UNKNOWN];
    }


    // J ****************************************
protected:



private:
    //////////////////////////////////////////////////
    /// \brief =
    ///
    /// ȂB
    /// 
    GLGTMouse_Singleton& operator =(const GLGTMouse_Singleton& in) const {}





};

#endif
