/***************************************************
* 
* GLGTShapes_SingletonGLGTInitŃRXgNgA
* GLGTQuitŃfXgNgB
* 
* 
* 
* 
* 
* 
* 
* 
***************************************************/
//********************************************************************
/// \file 
/// 
/// 
/// 
/// 
//********************************************************************
#ifndef _GLGTSHAPES_H_
#define _GLGTSHAPES_H_

#include "GLGTBase.h"
#include "GLGTSingleton.h"

#define GLGTShapes    GLGTShapes_Singleton::getSingleton() ///< CX^XɃANZX
#define ptrGLGTShapes    GLGTShapes_Singleton::getSingletonPtr()  ///< CX^X̃|C^ɃANZX


//********************************************************************
/// \brief }EXVOgNX
///
/// GLGTShapes_SingletonGLGTInitŃRXgNgA
/// GLGTQuitŃfXgNgB<BR>
/// GLGTShapesŃCX^XɃANZX (FGLGTShapes.drawRect())
/// 
/// 
class GLGTShapes_Singleton : public GLGTSingleton <GLGTShapes_Singleton> {

    // vpeB ****************************************
public:



protected:
    float cubeNormal[6][3]; ///< cube̖@f[^
    unsigned int cubeFace[6][4]; ///< cube̖ʃf[^



private:


  // C^[tFCX ****************************************
public:
    //////////////////////////////////////////////////
    /// \brief RXgN^
    GLGTShapes_Singleton(void);

    //////////////////////////////////////////////////
    /// \brief fXgN^
    ~GLGTShapes_Singleton();



    //////////////////////////////////////////////////
    /// \brief clear
    void clear(void);


    //////////////////////////////////////////////////
    /// \brief drawRect
    /// \param width 
    /// \param height 
    void drawRect(float width, float height){
        float width_ = width/2;
        float height_ = height/2;
        glBegin(GL_QUADS);
        glNormal3f(0,0,1);
        glVertex3f( width_,  height_, 0);
        glVertex3f(-width_,  height_, 0);
        glVertex3f(-width_, -height_, 0);
        glVertex3f( width_, -height_, 0);
        glEnd();

    }

    //////////////////////////////////////////////////
    /// \brief drawTextureRect
    /// \param width 
    /// \param height 
    void drawTextureRect(float width, float height){
        float width_ = width/2;
        float height_ = height/2;
        glBegin(GL_QUADS);
        glNormal3f(0,0,1);
        glTexCoord2f(1.0, 1.0);
        glVertex3f( width_,  height_, 0);
        glTexCoord2f(0.0, 1.0);
        glVertex3f(-width_,  height_, 0);
        glTexCoord2f(0.0, 0.0);
        glVertex3f(-width_, -height_, 0);
        glTexCoord2f(1.0, 0.0);
        glVertex3f( width_, -height_, 0);
        glEnd();

    }

    //////////////////////////////////////////////////
    /// \brief ̂`
    /// \param size ӂ̒
    void drawCube(float size){

        float v[8][3];

        v[0][0] = v[1][0] = v[2][0] = v[3][0] = -size / 2.0f;
        v[4][0] = v[5][0] = v[6][0] = v[7][0] =  size / 2.0f;
        v[0][1] = v[1][1] = v[4][1] = v[5][1] = -size / 2.0f;
        v[2][1] = v[3][1] = v[6][1] = v[7][1] =  size / 2.0f;
        v[0][2] = v[3][2] = v[4][2] = v[7][2] = -size / 2.0f;
        v[1][2] = v[2][2] = v[5][2] = v[6][2] =  size / 2.0f;

        for (int i = 0; i < 6; i++) {
            glBegin(GL_QUADS);
            glNormal3fv(&cubeNormal[i][0]);
            glVertex3fv(&v[cubeFace[i][0]][0]);
            glVertex3fv(&v[cubeFace[i][1]][0]);
            glVertex3fv(&v[cubeFace[i][2]][0]);
            glVertex3fv(&v[cubeFace[i][3]][0]);
            glEnd();
        }

    }
    
    //////////////////////////////////////////////////
    /*
    void DrawSphere(unsigned int radius, unsigned int division_vertical, unsigned int division_horizontal){
        if(division_vertical < 3) {
            division_vertical = 3;
        }
        if(division_horizontal < 2) {
            division_horizontal = 2;
        }


    }
    */

    
    
    
    // J ****************************************
protected:



private:
    //////////////////////////////////////////////////
    /// \brief =
    ///
    /// ȂB
    /// 
    GLGTShapes_Singleton& operator =(const GLGTShapes_Singleton& in) const {}




    
    
    

};


#endif
