//********************************************************************
/// \file
/// 
/// 
/// 
/// 
//********************************************************************
#include "GLGTBase.h"



//////////////////////////////////////////////////
/// \brief AT[g֐
/// 
/// GLGTASSERT(exp)ŌĂ΂B
/// G[bZ[W̌ɑs邩~邩邩IԁB
/// 
/// 
/// \param expression ̕
/// \param filename t@C(__FILE__)
/// \param lineno \[X̍s(__LINE__)
/// \param ignore 邩ǂ̃tO
/// \retval true u[N
/// \retval false s
bool GLGTAssertFunction(const char* expression, const char* filename, unsigned int lineno, bool* ignore){
    if(*ignore){ 
        return false;
    }

    int button;
    char msg[256];
    sprintf(msg, "GLGTASSERT\n\n%s(%u)\n\n\"%s\"\n\nignore? [ ignore(YES) / continue(NO) / debug(CANCEL) ]",
        filename, lineno, expression);
    button = MessageBox(NULL , TEXT(msg) ,TEXT("GLGTASSERT") ,
        MB_YESNOCANCEL | MB_ICONQUESTION | MB_DEFBUTTON3 | MB_SETFOREGROUND);

    switch(button) {
        case IDYES:
            *ignore = true;
            return false;
        case IDNO:
            return false;
            break;
        case IDCANCEL:
            return true;
            break;
            break;
    }




    //ȉwindowsȊO̊p
    /*
    std::cerr << filename << ":" << lineno << ": GLGTASSERT(" << expression << ") failed." << std::endl;
    std::cout << "continue? [Yes(y)/No(n)/Ignore(i)] :" << std::flush;

    char reply = 'n';
    std::cin >> reply;
    
    switch(reply) {
        case 'y':
        case 'Y':
            std::cout << "continue." << std::endl;
            return false;
            break;
        case 'n':
        case 'N':
            std::cout << "Break." << std::endl;
            return true;
            break;
        case 'i':
        case 'I':
            std::cout << "Ignore." << std::endl;
            *ignore = true;
            return false;
            break;
    }
    */

    return false; //default:

}




//////////////////////////////////////////////////
/// \brief OpenGLG[`FbN֐
/// 
/// GLGTCHECKGLERROR()ŌĂ΂B
/// G[bZ[W̌ɑs邩~邩邩IԁB
/// 
/// 
/// \param err G[̎
/// \param filename t@C(__FILE__)
/// \param lineno \[X̍s(__LINE__)
/// \param ignore 邩ǂ̃tO
/// \retval true u[N
/// \retval false s
bool GLGTCheckGLErrorFunction(GLenum err, const char* filename, unsigned int lineno, bool* ignore) {
    if(*ignore){ 
        return false;
    }

    int button;
    char msg[256];
    sprintf(msg, "GLGTCHECKGLERROR\n\n%s(%u)\n\n\"%s\"\n\nignore? [ ignore(YES) / continue(NO) / debug(CANCEL) ]",
        filename, lineno, gluErrorString(err));
    button = MessageBox(NULL , TEXT(msg) ,TEXT("GLGTCHECKGLERROR") ,
        MB_YESNOCANCEL | MB_ICONQUESTION | MB_DEFBUTTON3 | MB_SETFOREGROUND);

    switch(button) {
        case IDYES:
            *ignore = true;
            return false;
        case IDNO:
            return false;
            break;
        case IDCANCEL:
            return true;
            break;
            break;
    }

    return false; //default:

}
