#include "GLGT.h"
#include <iostream>

using namespace std;

int main(void) {
    GLGTInit();


    string fn("C:/cpp_program/hello.cpp");
    string fn_path = GLGTUtility.getFilePath(fn);
    string fn_name = GLGTUtility.getFileName(fn);
    string fn_ext = GLGTUtility.getFileExtensions(fn);
    string fn_cpp_to_cg(fn);
    GLGTUtility.replaceString(fn_cpp_to_cg, string("cpp"), string("cg"));

    cout << "orig[" << fn.c_str() << "],\npath[" << fn_path.c_str() << "],\nfilename[" << fn_name.c_str() << "],\n";
    cout << "ext[" << fn_ext.c_str() << "],\n"<< "replace[" << fn_cpp_to_cg.c_str() << "]" <<endl;
    vector<string> fn_parsed_path;
    GLGTUtility.parseFilePath(fn_parsed_path,fn);
    cout << "parse";
    for(unsigned int i = 0; i < fn_parsed_path.size(); i++) {
        cout << '[' << fn_parsed_path[i].c_str() << ']';
    }
    cout << "\n"<<endl;

    string str("   aiueo       kakikukeko\"sasisuseso\"tatituteto\"naninuneno\" hahihuheho");
    std::vector<std::string> parsed;
    GLGTUtility.parseString(parsed, str);
        cout << '[' << str << ']';
    for(unsigned int i = 0; i < parsed.size(); i++) {
        cout << '[' << parsed[i].c_str() << "]\n";
    }
    cout <<endl;

    GLGTQuit();
}